package com.huiju.welcome.utils;

import java.util.ArrayList;
import java.util.List;

public class LogBuilder {
    private List<String> content = new ArrayList<>();

    public LogBuilder append(String name, String value) {
        if (null == value || "".equals(value.trim())) return this;
        content.add(String.format("【%s】 %s ", name, value));
        return this;
    }

    public LogBuilder append(String ctt) {
        if (null == ctt || "".equals(ctt.trim())) return this;
        content.add(ctt);
        return this;
    }

    public LogBuilder append(String name, String before, String after) {
        if ((null == before || "".equals(before.trim())) && (null == after || "".equals(after.trim()))) return this;

        if (null == before) before = "null";
        if (null == after) after = "null";

        if (before.equals(after)) return this;

        content.add(String.format("【%s】 修改前 %s, 修改后 %s", name, before, after));
        return this;
    }

    public String build() {
        String result = String.join(" ; ", content);
        content.clear();
        return result;
    }
}
